/********************************/
/*                              */
/*         ccom.c               */
/*                              */
/* Compiler zur Erzeugung von   */
/* C-Code Quellprogrammen zur   */
/* Aufbereitung und Analyse von */
/* Umfragedaten.                */
/*                              */
/* prog: V. Hoffmann            */
/********************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include "ccom.def"

long l          = 0;
int datgen      = 0;
int out1_yes    = 1;
short endfound  = 0;
short afound    = 0;
short tabcount  = 0;
short errcount  = 0;
unsigned short nccount = 0;
short ncount    = 0;
short bcount    = 0;
short nnumcount = 0;
short ncidx     = 0;
short ncmax     = 0;
short tabidx    = 0;
short bufidx    = 0;
short incidx    = 0;
short incvor    = 0;
int incadd    = 0;
unsigned short tabor = 0;
short fltline   = 0;
short tabline   = 0;
short t_case    = 0;
short fltfound  = 0;
short fltcount  = 0;
short tabfound  = 0;
short fltopts   = 0;
short nffound   = 0;
short nfline    = 0;
short ifline    = 0;
short ifprec    = 0;
short elprec    = 0;
short thprec    = 0;
short isif      = 0;
short klcount   = 0;
short parcount  = 0;
short lfound    = 0;
short lregion   = 0;
short subfound  = 0;
short lline     = 0;
short aline     = 0;
short axignore  = 0;
short fltignore = 0;
short tabignore = 0;
short nfignore  = 0;
short nignore   = 1;
int recpos    = 0;
short trcount   = 0;
short trcount_p = 0;
short edfound   = 0;
short isedit    = 0;
short isset     = 0;
short isemit    = 0;
short isdel     = 0;
short ismask    = 0;
short iscolint  = 0;
short iscolreal = 0;
short iscall    = 0;
short isfnam    = 0;
short isstruct  = 0;
short isreq     = 0;
short isrep     = 0;
short accode    = 3;
short nologo    = 0;
short nodata    = 0;
char mp_char   = '*';
short netlevel  = 0;
short netpar    = 0;
short netstart[10] = {0};
unsigned short netbit[10] = {0};
short netindex[10] = {0};
int sreadtype   = 0;
int scrdstart   = 0;
int scrdlen     = 0;
int sserstart   = 0;
int sserlen     = 0;
int smaxcrd     = 0;
int sdummy1     = 0;
int sdummy2     = 0;
int sreclen     = 0;
int srecl       = 0;
int writecount  = 0;
int hccount     = 0;
int listcount   = 0;
int pcnt        = 0;
short doidx     = 0;
short enddo     = 0;
short t_val     = 0;
short t_par     = 0;
short sreq      = 0;
short isc       = 0;
short v1        = 0;
short v2        = 1;
short issub     = 0;
short onlfound  = 0;
short wrtfound  = 0;
short sedfound  = 0;
short nobounds  = 0;
short debug     = 0;
short check     = 0;
short errprint  = 20;
short sfound    = 0;
short nfound    = 0;
short iscplace  = 0;
short ispplace  = 0;
short istplace  = 0;
short isincline = 0;
short isinccnt  = 0;
short isplold[16];
short vcmerk    = 0;
short israise   = 0;
int wmlevs_     = 0;
int registered  = 0;
int tf          = 0;
int s_err       = 0;
short iscon     = 0;
short isinc     = 0;
float facval    = (float)0.0;
short status_flag_1 = 0;
int reqpar      = 0;
int reqcode     = 2;
char echr[] = {0x7f,'\0'};
short errindx[100] = {0};
int colvar[32] = {0};
short p_num      = 0;
short n_num      = 0;
unsigned short punchvar[32] = {0};
struct axesdef axlm;
struct tabopts opt_a;
struct tabopts opt_l;
struct tabopts opt_f;
struct tabroute tr[TABROUTESIZE];
unsigned maxdata = 0;
char varnam[1001][16] = {"c","t","x","cx","pre","lastrec","firstread","lastread","thisread","allread","rejected_","rec_rej","rec_acc","rec_count","printed_","trun_" ,"escape_"};
unsigned varsub[1001] = {100, 200, 100, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
short    vargen[1001] = {USHORT, LONG, DOUBLE, COLDBL, DOUBLE, SHORT, SHORT, SHORT, LONG, LONG, SHORT, LONG, LONG, LONG, SHORT, SHORT, LONG };
short    varidx[1001] = {ISIDX, ISIDX, ISIDX, ISIDX, NOIDX, NOIDX, NOIDX, NOIDX, ISIDX, ISIDX, NOIDX, NOIDX, NOIDX, NOIDX, NOIDX, NOIDX, NOIDX };
short    varopt[1001] = {ISOPT, ISOPT, ISOPT, NOOPT, NOOPT, NOOPT, NOOPT, NOOPT, ISOPT, ISOPT, NOOPT, NOOPT, NOOPT, NOOPT, NOOPT, NOOPT, NOOPT };
short    varpre[1001] = {ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE, ISPRE };
short    varfnc[1001] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
short varcnt = 17;
short recset = 0;
unsigned short pval[128];
char pnam[10][18];
char tnam[16][18];
char *ttext[16];
char *ctab[512];
char ccpath[256];
char *inlin;
char *queue;
char *kn_;
char *on_[32];
short on_c = 0;
long on_l[32];
char filnam[MAXFILE][13] = {"out2"};
short filgen[MAXFILE]    = {PRINT};
short filout[MAXFILE]    = {NORM};
short filrul[MAXFILE]    = {1};
short filser[MAXFILE]    = {1};
int   fillen[MAXFILE]    = {0};
char *filtxt[MAXFILE]    = {"Ccount (C) V. Hoffmann  -  edit report"};
short filcnt   = 1;
short ii_;
short i,j,k;
char tabnam[501][16];
char lnam[501][16];
char lastname[16];
long dolab_[10];
long label_[501];
long goto_[501];
short domax    = 0;
short labelidx = 0;
short gotoidx  = 0;
long lbtmp     = 0;
unsigned diffa      = 0;
unsigned diffb      = 0;
short ptl           = 0;
char *wbuf;
char *tbuf;
char *tabb;
char *conb;
char *wbuf_;
char zbuf[INSIZE];
char abuf[512];
char bbuf[512];
char cbuf[512];
char pbuf[201];
short count;
short len,kennz;
int mjn,kl,ll,m,n;
FILE *fpq;
FILE *fpp;
FILE *fpv;
FILE *fpf;
FILE *fpc;
FILE *fpr;
FILE *fpu;
FILE *fpa;
FILE *fpb;
FILE *fpe;
FILE *fpg;
FILE *fph;
FILE *fpi;
unsigned short qval[ ] = {
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x0000,
0x0482,0x0006,0x0042,0x0442,0x0222,0x0800,0x0012,0x0812,0x0412,0x0422,0x080a,
0x0242,0x0400,0x0842,0x0300,0x0200,0x0100,0x0080,0x0040,0x0020,0x0010,0x0008,
0x0004,0x0002,0x0001,0x0082,0x040a,0x0822,0x000a,0x020a,0x0206,0x0022,0x0900,
0x0880,0x0840,0x0820,0x0810,0x0808,0x0804,0x0802,0x0801,0x0500,0x0480,0x0440,
0x0420,0x0410,0x0408,0x0404,0x0402,0x0401,0x0280,0x0240,0x0220,0x0210,0x0208,
0x0204,0x0202,0x0201,0x1fff,0x0282,0x1fff,0x1fff,0x0212,0x0902,0x0b00,0x0a80,
0x0a40,0x0a20,0x0a10,0x0a08,0x0a04,0x0a02,0x0a01,0x0d00,0x0c80,0x0c40,0x0c20,
0x0c10,0x0c08,0x0c04,0x0c02,0x0c01,0x0680,0x0640,0x0620,0x0610,0x0608,0x0604,
0x0602,0x0601,0x0a00,0x0882,0x0600,0x0700,0x0000,
0x2001,0x2002,0x2003,0x2004,0x2005,0x2006,0x2007,0x2008,0x2009,0x200a,0x200b,
0x200c,0x200d,0x200e,0x200f,0x2010,0x2011,0x2012,0x2013,0x2014,0x2015,0x2016,
0x2017,0x2018,0x2019,0x201a,0x201b,0x201c,0x201d,0x201e,0x201f,0x2020,0x2021,
0x2022,0x2023,0x2024,0x2025,0x2026,0x2027,0x2028,0x2029,0x202a,0x202b,0x202c,
0x202d,0x202e,0x202f,0x2030,0x2031,0x2032,0x2033,0x2034,0x2035,0x2036,0x2037,
0x2038,0x2039,0x203a,0x203b,0x203c,0x203d,0x203e,0x203f,0x2040,0x2041,0x2042,
0x2043,0x2044,0x2045,0x2046,0x2047,0x2048,0x2049,0x204a,0x204b,0x204c,0x204d,
0x204e,0x204f,0x2050,0x2051,0x2052,0x2053,0x2054,0x2055,0x2056,0x2057,0x2058,
0x2059,0x205a,0x205b,0x205c,0x205d,0x205e,0x205f,0x2060,0x2061,0x2062,0x2063,
0x2064,0x2065,0x2066,0x2067,0x2068,0x2069,0x206a,0x206b,0x206c,0x206d,0x206e,
0x206f,0x2070,0x2071,0x2072,0x2073,0x2074,0x2075,0x2076,0x2077,0x2078,0x2079,
0x207a,0x207b,0x207c,0x207d,0x207e,0x207f,0x2080
                         } ; /* 0x0000, da Compiler Blanks in 0x7f umwandelt */
char qfolg[ ] = "&-01234567890-&";
char *errtab[] = {
  "",
  "ERROR: (%s) integer keyword is outside permitted range",                          /*   1 */
  "ERROR: axisname not defined",                                                     /*   2 */
  "ERROR: do loop not terminated",                                                   /*   3 */
  "ERROR: no multiplier specified on n25",                                           /*   4 */
  "ERROR: bad dimensionality of tab statement",                                      /*   5 */
  "ERROR: invalid axis name",                                                        /*   6 */
  "ERROR: too many open files",                                                      /*   7 */
  "ERROR: incorrect specification of variable",                                      /*   8 */
  "ERROR: too many variables",                                                       /*   9 */
  "ERROR: incorrect specification of subroutine variable",                           /*  10 */
  "ERROR: incorrect entry in list definition",                                       /*  11 */
  "ERROR: improper specification of do loop",                                        /*  12 */
  "ERROR: bad do loop termination",                                                  /*  13 */
  "ERROR: file name not defined",                                                    /*  14 */
  "ERROR: syntax error",                                                             /*  15 */
  "ERROR: unanalyzable text in expression",                                          /*  16 */
  "ERROR: variable is not of expected type",                                         /*  17 */
  "ERROR: unbalanced parentheses",                                                   /*  18 */
  "ERROR: cannot interpret condition",                                               /*  19 */
  "ERROR: = missing in keyword (%s)",                                                /*  20 */
  "ERROR: only digits 0-9 allowed in numeric field",                                 /*  21 */
  "ERROR: if not followed by (",                                                     /*  22 */
  "WARNING: A card found with no tab statements",                                    /*  23 */
  "ERROR: 0 value label",                                                            /*  24 */
  "ERROR: too many labels in run",                                                   /*  25 */
  "ERROR: multiply defined label",                                                   /*  26 */
  "ERROR: too many defines",                                                         /*  27 */
  "ERROR: label never defined",                                                      /*  28 */
  "ERROR: else without preceding if",                                                /*  29 */
  "WARNING: axis name truncated to 15 characters",                                   /*  30 */
  "ERROR: axis name is multiply defined",                                            /*  31 */
  "ERROR: error in string type logical condition",                                   /*  32 */
  "ERROR: cannot interpret set statement",                                           /*  33 */
  "ERROR: multiply defined variable",                                                /*  34 */
  "ERROR: illegal format for report statement",                                      /*  35 */
  "ERROR: keyword has spurious characters at end",                                   /*  36 */
  "ERROR: $ or ' missing or not in matched pair",                                    /*  37 */
  "ERROR: illegally defined variable subscripts",                                    /*  38 */
  "ERROR: illegal format for filedef statement",                                     /*  39 */
  "ERROR: improper subscripted col variable",                                        /*  40 */
  "ERROR: incorrect form of priority statement",                                     /*  41 */
  "ERROR: invalid character in variable name",                                       /*  42 */
  "ERROR: emit/delete/mask incorrectly specified",                                   /*  43 */
  "ERROR: incorrect specification of partial column move",                           /*  44 */
  "ERROR: illegal file type",                                                        /*  45 */
  "ERROR: p/q multipunch specification incorrect",                                   /*  46 */
  "ERROR: inproper left side of real column assignment",                             /*  47 */
  "ERROR: incorrect text to left of .in.",                                           /*  48 */
  "ERROR: C variable expected",                                                      /*  49 */
  "ERROR: illegal combination of keywords in struct statement",                      /*  50 */
  "ERROR: cannot recognize right side of =",                                         /*  51 */
  "ERROR: setting/comparing different numbers of columns",                           /*  52 */
  "ERROR: variable subscript out of range",                                          /*  53 */
  "ERROR: incorrect statement type",                                                 /*  54 */
  "ERROR: cannot open specified file",                                               /*  55 */
  "ERROR: same punch used in nested loops",                                          /*  56 */
  "ERROR: text allocation error",                                                    /*  57 */
  "ERROR: multiply defined filename",                                                /*  58 */
  "ERROR: do loops nested too deeply",                                               /*  59 */
  "ERROR: reserved variable name",                                                   /*  60 */
  "WARNING: C subscript < 101 with multi-card job",                                  /*  61 */
  "WARNING: reclen with value > 100 found",                                          /*  62 */
  "ERROR: multi-card job may not have reclen > 1000",                                /*  63 */
  "ERROR: c= missing text on keyword",                                               /*  64 */
  "ERROR: premature end of file",                                                    /*  65 */
  "WARNING: chars/cols in source < cols in destination",                             /*  66 */
  "WARNING: specification of (m,n) where m = n",                                     /*  67 */
  "ERROR: punch expected",                                                           /*  68 */
  "ERROR: action code must be between 0 and 3",                                      /*  69 */
  "ERROR: named variable defined after executable statement",                        /*  70 */
  "WARNING: online found without creating a new data file",                          /*  71 */
  "WARNING: online found without specifying a serial number",                        /*  72 */
  "ERROR: stats element has no elements on which to calculate statistic",            /*  73 */
  "ERROR: improper col or punch definition",                                         /*  74 */
  "ERROR: improper c=- or c=+ condition",                                            /*  75 */
  "ERROR: then without preceding if",                                                /*  76 */
  "ERROR: endif without preceding if-then condition",                                /*  77 */
  "ERROR: missing endif",                                                            /*  78 */
  "ERROR: illegal format for display statement",                                     /*  79 */
  "ERROR: multi-input incorrectly specified",                                        /*  80 */
  "ERROR: keyword (%s) cannot appear on this statement",                             /*  81 */
  "ERROR: limit of number of axes in run exeeded",                                   /*  82 */
  "ERROR: missing text on keyword (%s)",                                             /*  83 */
  "ERROR: improper op= definition",                                                  /*  84 */
  "ERROR: symbolic name too long",                                                   /*  85 */
  "ERROR: includes nested too deeply",                                               /*  86 */
  "ERROR: number of p card points does not match axis def",                          /*  87 */
  "ERROR: keyword (%s) not identifiable",                                            /*  88 */
  "ERROR: keyword (%s) has invalid characters at end",                               /*  89 */
  "ERROR: a digit must follow NET/NETEND",                                           /*  90 */
  "ERROR: missing net level",                                                        /*  91 */
  "ERROR: this statement cannot have a condition",                                   /*  92 */
  "ERROR: job may not have reclen > 99999",                                          /*  93 */
  "ERROR: keyword duplicated (%s)",                                                  /*  94 */
  "WARNING: command not implemented yet (%s)",                                       /*  95 */
  "ERROR: and without preceding tab found",                                          /*  96 */
  "ERROR: variable name (%s) too long",                                              /*  97 */
  "ERROR: undefined subroutine parameter(s)",                                        /*  98 */
  "ERROR: function name must be followed by ("                                       /*  99 */
                 } ;

struct ntypes nvals[] = {
NULL,-1,-1,-1,-1,-1,-1,
"n01"       ,3,1,1,1,0,0,   /*  1 */
"n15"       ,3,1,1,1,0,0,   /*  2 */
"n10"       ,3,1,1,1,0,0,   /*  3 */
"n11"       ,3,1,1,1,0,0,   /*  4 */
"n25"       ,3,1,1,1,0,0,   /*  5 */
"n03"       ,3,1,0,0,0,0,   /*  6 */
"n33"       ,3,1,0,0,0,0,   /*  7 */
"n09"       ,3,1,0,0,0,0,   /*  8 */
"ttl"       ,3,1,0,0,0,0,   /*  9 */
"n12"       ,3,1,0,0,0,0,   /* 10 */
"n17"       ,3,1,0,0,0,0,   /* 11 */
"n04"       ,3,1,0,0,0,0,   /* 12 */
"n05"       ,3,1,0,0,0,0,   /* 13 */
"n13"       ,3,1,0,0,0,0,   /* 14 */
"tab"       ,3,0,1,0,0,1,   /* 15 */
"flt"       ,3,0,1,0,0,1,   /* 16 */
"n00"       ,3,1,1,0,0,0,   /* 17 */
"l "        ,2,0,1,0,1,1,   /* 18 */
"n19"       ,3,1,0,0,0,0,   /* 19 */
"ttc"       ,3,1,0,0,0,0,   /* 20 */
"ttr"       ,3,1,0,0,0,0,   /* 21 */
"g"         ,1,1,0,0,0,0,   /* 22 */
"pag"       ,3,0,0,0,0,0,   /* 23 */
"p"         ,1,1,0,0,0,0,   /* 24 */
"netend"    ,6,1,0,0,0,0,   /* 25 */
"net"       ,3,1,0,1,0,0,   /* 26 */
"n23"       ,3,1,0,0,0,0,   /* 27 */
"and"       ,3,0,1,0,0,1,   /* 28 */
NULL,-1,-1,-1,-1,-1,-1
};

char *resvar_[] = {
"r",
"require",
"stop",
"write",
"print",
"count",
"clear",
"filedef",
"definelist",
"data",
"int",
"real",
"goto",
"go",
"to",
"if",
"or",
"and",
"xor",
"lt",
"le",
"eq",
"ge",
"gt",
"in",
"ne",
"priority",
"continue",
"online",
"do",
"numb",
"range",
"rangeb",
"read",
"display",
"cancel",
"system",
"nologo",
"nodata",
"mpchar",
"beep",
"single",
"num",
"escape",
"noescape",
"reclen",
"struct",
"crd",
"ser",
"req",
"rqd",
"ed",
"delete",
"mask",
"emit",
"set",
"process",
"return",
"subroutine",
"call",
"end",
"list",
"lista",
"listr",
"listc",
"explode",
"fetch",
"max",
"not",
"reject",
"else",
"report",
"reportn",
"random",
"rpunch",
"nobounds",
"debug",
"check_",
"nocheck_",
"errprint",
"col",
"punch",
"then",
"endif",
NULL } ;

main(argc,argv)
int argc;
char *argv[];
{
printf("\n");
if(getenv("CCHOME") == NULL)
  {
  printf("ccom: You have no \"CCHOME\" set\n");
  exit(1);
  }
strcpy(ccpath,getenv("CCHOME"));
printf("PAN-DATA CCOUNT - Compiler     Version 1.1d\n");
registered = testregister_();
printf("Created 12.03.2004        prog: V. Hoffmann\n\n");

on_l[on_c] = 0;
if((on_[on_c] = (char*)calloc((unsigned)80,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: on_[]");
  exit(1);
  }
if(argc < 2)
  {
  fpq = stdin;
  strcpy(on_[on_c],"\0");
  }
else
  {
  strcpy(on_[on_c],argv[1]);
  if((fpq = fopen(on_[on_c],"r")) == NULL)
    {
    puts("cannot open sourcefile");
    exit(1);
    }
  }
if(argc < 3)
  fpu = stdout;
else
  if((fpu = fopen(argv[2],"w")) == NULL)
    {
    puts("cannot open error log file");
    exit(1);
    }
if((fpp = fopen("ccvars.h","w")) == NULL)
  {
  puts("cannot open ccvars.h");
  exit(1);
  }
if((fpv = fopen("ccparams.h","w")) == NULL)
  {
  puts("cannot open ccparams.h");
  exit(1);
  }
if((fpf = fopen("ccfile.h","w")) == NULL)
  {
  puts("cannot open ccfile.h");
  exit(1);
  }
if((fpr = fopen("cctitel.inf","wb")) == NULL)
  {
  puts("cannot open cctitel.inf");
  exit(1);
  }
if((fpc = fopen("editC.c","w")) == NULL)
  {
  puts("cannot open editC.c");
  exit(1);
  }
if((fpa = fopen("tabsC.c","w")) == NULL)
  {
  puts("cannot open tabsC.c");
  exit(1);
  }
if((fpb = fopen("tabsC1.c","w")) == NULL)
  {
  puts("cannot open tabsC1.c");
  exit(1);
  }
if((fpe = fopen("axesC.c","w")) == NULL)
  {
  puts("cannot open axesC.c");
  exit(1);
  }
if((fpg = fopen("ccroute.inf","wb")) == NULL)
  {
  puts("cannot open ccroute.inf");
  exit(1);
  }
if((fph = fopen("ccreqs.h","w")) == NULL)
  {
  puts("cannot open ccreqs.h");
  exit(1);
  }
if((fpi = fopen("varsetC.c","w")) == NULL)
  {
  puts("cannot open varsetC.c");
  exit(1);
  }
if((inlin = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: inlin");
  exit(1);
  }
if((queue  = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: queue");
  exit(1);
  }
if((kn_    = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: kn_");
  exit(1);
  }
if((wbuf   = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: wbuf");
  exit(1);
  }
if((tbuf   = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: tbuf");
  exit(1);
  }
if((tabb   = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: tabb");
  exit(1);
  }
if((conb   = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: conb");
  exit(1);
  }
if((wbuf_  = (char*)calloc((unsigned)INSIZE,(unsigned)sizeof(char))) == NULL)
  {
  puts("memory allocation error: wbuf_");
  exit(1);
  }
for(ii_=1;ii_<MAXFILE;ii_++)
   {
   strcpy(filnam[ii_],"\0");
   filgen[ii_] = 0;
   filtxt[ii_] = NULL;
   filout[ii_] = NORM;
   filrul[ii_] = 1;
   filser[ii_] = 1;
   fillen[ii_] = 0;
   }

opt_a.flag_1 = FLAG_1_DEFAULT;
opt_a.opval  = OPVAL_DEFAULT;
opt_a.dpval  = DPVAL_DEFAULT;
opt_a.dcval  = DCVAL_DEFAULT;
opt_a.colwid = COLWID_DEFAULT;
opt_a.paglen = PAGLEN_DEFAULT;
opt_a.pagwid = PAGWID_DEFAULT;
opt_a.side   = SIDE_DEFAULT;
*(opt_a.spechr+0) = 0x7f;
*(opt_a.spechr+1) = 0x7f;
tr[trcount].pagenum = 0;
tr[trcount].fltnum = 0;
strcpy(pbuf,"Page");
ptl = 4;

strcpy(queue,"\0");
readline_(0,fpq);

printf("%ld lines compiled.  There were %d errors encountered.\n\n",l,errcount);

/* Programmende */
fclose(fpp);
fclose(fpv);
fclose(fpf);
fclose(fpc);
fclose(fpr);
fclose(fpu);
fclose(fpa);
fclose(fpb);
fclose(fpe);
fclose(fpg);
fclose(fph);
fclose(fpi);

n = 0;
if(errcount)
  n = 1;
exit(n);
}

void readline_(sign_,fptr)
int sign_;
FILE *fptr;
{
int plen;
int pk = 0;

while((fgets(inlin,INSIZE,fptr)) != NULL)
  {
  if(!strncmp(inlin,"#c",2))
    {
    isc = 1; ++l;
    cond(queue);
    continue;
    }
  else
  if(!strncmp(inlin,"#endc",5))
    {
    isc = 0; ++l;
    continue;
    }
  else
  if(isc)
    {
    ++l;
    fprintf(fpc,"%s",inlin);
    continue;
    }
  plen = strlen(inlin)-1;
  if(plen && *(inlin+(plen-1)) == 0x0d)
    *(inlin+(--plen)) = '\0';
  if(plen)
    *(inlin+plen) = ' ';
  while(plen)
    {
    if(*(inlin+plen) == ' ')
      *(inlin+plen) = '\0';
    else
      break;
    --plen;
    }
  if(dirct(inlin))
    {
    cond(queue);
    cond(inlin);
    }
  else
  if(*(inlin+0) != '+')
    {
    if(pk)
      cond(queue);
    strcpy(queue,inlin);
    }
  else
  if((plen > 2) && !strncmp(inlin,"++",2))
    strcat(queue,inlin+2);
  else
  if((plen > 1) && !strncmp(inlin,"+",1))
    {
    *(inlin+0) = ';';
    strcat(queue,inlin);
    }
  pk = 1; ++l; ++on_l[on_c];
  if(!registered)
    {
    if(l > 200L)
      {
      printf("**** UNREGISTERED VERSION: 200 lines exceeded ****\n\n");
      exit(1);
      }
    }
  }
if(isc)
  errmsg("\0", 65);
else
  {
  cond(queue);
  if(!sign_)
    {
    out1_yes = 0;
    if(!edfound)
      {
      nignore  = 1;
      cond("ed");
      }
    if(!endfound || afound)
      {
      nignore = 1;
      cond("end");
      }
    cond("ed_dummy_command");
    }
  }
}

void cond(s)
char *s;
{
FILE *fptr;
static char *outline;
char fn_[256];
int i_,l_,j_;

  strcpy(kn_,left(s));
  if(out1_yes && isout_(s))
    writeout1_(s);
  if((i_ = isinc_(kn_)))
    {
    if(isinccnt >= 6)
      {
      errmsg("\0", 86);
      goto F_END;
      }
    isplold[isinccnt] = istplace;
    if((on_[++on_c] = (char*)calloc((unsigned)80,(unsigned)sizeof(char))) == NULL)
      {
      puts("memory allocation error: on_[]");
      exit(1);
      }
    on_l[on_c] = 0;
    strcpy(on_[on_c],getdatnam_(kn_,i_));
    if(istplace)
      substitute_(on_[on_c]);
    l_ = strlen(s); i_ = 0;
    for(j_=0;j_<l_;j_++)
       if(*(s+j_) == ';')
         {
         i_ = 1;
         break;
         }
    if(i_)
      {
      strcpy(kn_,left(s+j_+1));
      sreq = 1; kl = 0; isincline = 1;
      if(istplace)
        substitute_(kn_);
      edintp(kn_);
      }
    if((fptr = fopen(on_[on_c],"r")) == NULL)
      {
      --on_c;
      errmsg("\0", 55);
      if(s_err <= 20)
        fprintf(stderr,"File not found is %s\n",on_[on_c+1]);
      errindx[55] = 0;
      }
    else
      {
      ++isinccnt;
      readline_(1,fptr);
      fclose(fptr);
      strcpy(fn_,"**** end of file ");
      strcat(fn_,on_[on_c]);
      free(on_[on_c--]);
      writeout1_(fn_);
      for(j_=isplold[--isinccnt];j_<istplace;j_++)
         free(ttext[j_]);
      istplace = isplold[isinccnt];
      if(!isinccnt)
        {
        for(j_=0;j_<32;j_++)
           {
           colvar[j_]   = 0;
           punchvar[j_] = 0;
           }
        iscplace = 0; ispplace = 0;
        }
      }
    }
  else
  if(isout_(s) && *(kn_+0) != '\0')
    {
    fltline = 0; tabline = 0; lline = 0; aline = 0; nfline = 0; ifline = 0; isif = 0;
    isset = 0; isemit = 0; isdel = 0; iscolint = 0; iscolreal = 0; iscall = 0; isfnam = 0;
    isstruct = 0; parcount = 0; enddo = 0; t_par = 0; sreq = 1; kl = 1;
    fltignore = 0; tabignore = 0; nfignore = 0; v1 = v2; v2 = 0; elprec = 0; status_flag_1 = 0;
    isincline = 0; ismask = 0;
    axlm.genre      = 0;
    axlm.option     = 0;
    axlm.txtn       = 0;
    axlm.ttlnum     = 0;
    axlm.fltnum     = 0;
    axlm.flag_1     = 0;
    axlm.opval      = 0;
    axlm.dpval      = 0;
    axlm.dcval      = 0;
    axlm.colwid     = 0;
    if(!thprec)
      ifprec = 0;
    if(!afound)
      outline = (char*)edintp(kn_);
    else
      outline = (char*)tabintp(kn_);
    if(*(outline + 0) != '\0')
      {
      outline = unformat(outline);
      switch(datgen)
        {
        case EDITDAT:
          {
          if(!v2 && !sedfound)
            {
            if(subfound)
              errmsg("\0", 98);
            fprintf(fpc,"lb_start_ed: ;\n");
            sedfound = 1;
            }
          if(debug)
            fprintf(fpc,"\n/* %s (%ld): %s */\n",on_[on_c],on_l[on_c],queue);
          fprintf(fpc,"%s\n",outline);
          break;
          }
        case ATABDAT:
          {
          if(debug)
            fprintf(fpa,"\n/* %s (%ld): %s */\n",on_[on_c],on_l[on_c],queue);
          fprintf(fpa,"%s\n",outline);
          break;
          }
        case LTABDAT:
          {
          if(debug)
            fprintf(fpe,"\n/* %s (%ld): %s */\n",on_[on_c],on_l[on_c],queue);
          fprintf(fpe,"%s\n",outline);
          break;
          }
        default:
          {
          errmsg("\0", 16);
          break;
          }
        }
      }
    }
F_END: ;
strcpy(queue,"\0");
}

char *edintp(buf)
char *buf;
{
strcpy(buf,formatline(buf));
if(!strncmp("ERROR 0",buf,7))
  errmsg("\0", 37);

len = strlen(buf);
count = 0; mjn = 0;
for(i=0;i<len;i++)
   {
   if(*(buf + i) != ' ')
     {
     if(!mjn)
       {
       ctab[count++] = buf + i;
       mjn = 1;
       }
     }
     else
     {
     *(buf + i) = '\0';
     mjn = 0;
     }
   }

*(wbuf+0) = '\0';
for(i=0;i<count;i++)
   {
   if(afound)
     goto AFOUND;
   else
   if(ifline)
     goto IFLINE;
   else
   if(isstruct)
     goto ISSTRUCT;
   else
   if(iscall)
     goto ISCALL;
   else
     goto NO_IFLINE;

ISCALL: ;
   if(!strcmp(ctab[i],","))
     {
     cmd_0005();
     continue;
     }
   if((m = colptr(i,count,abuf)))
     {
     cmd_0097();
     continue;
     }
   if((!isfnam) && isps(ctab[i]))
     {
     cmd_0098();
     continue;
     }
   if(isstr(ctab[i]))
     {
     cmd_0105();
     continue;
     }
   goto OTHER;

ISSTRUCT: ;
   if(!strcmp(ctab[i],"read"))
     {
     cmd_0015();
     continue;
     }
   if(!strcmp(ctab[i],"max"))
     {
     cmd_0016();
     continue;
     }
   if(!strcmp(ctab[i],"ser"))
     {
     cmd_0017();
     continue;
     }
   if(!strcmp(ctab[i],"crd"))
     {
     cmd_0018();
     continue;
     }
   if(!strcmp(ctab[i],"req"))
     {
     cmd_0019();
     continue;
     }
   if(!strcmp(ctab[i],"reclen"))
     {
     cmd_0089();
     continue;
     }
   if(!strcmp(ctab[i],"nologo"))
     {
     cmd_0118();
     continue;
     }
   if(!strcmp(ctab[i],"nodata"))
     {
     cmd_0120();
     continue;
     }
   if(!strcmp(ctab[i],"mpchar"))
     {
     cmd_0138();
     continue;
     }
   if(!strcmp(ctab[i],"rep"))
     {
     cmd_0145();
     continue;
     }
   goto OTHER;

AFOUND: ;
   if(((i+1) < count) && !strcmp(ctab[i],"c") && !strcmp(ctab[i+1],"="))
     {
     cmd_0051();
     continue;
     }
   if(!strcmp(ctab[i],"n01") && sreq)
     {
     cmd_0052();
     continue;
     }
   if(!strcmp(ctab[i],"n15") && sreq)
     {
     cmd_0053();
     continue;
     }
   if(!strcmp(ctab[i],"n10") && sreq)
     {
     cmd_0054();
     continue;
     }
   if(!strcmp(ctab[i],"n11") && sreq)
     {
     cmd_0055();
     continue;
     }
   if(!strcmp(ctab[i],"n25") && sreq)
     {
     cmd_0056();
     continue;
     }
   if(!strcmp(ctab[i],"n03") && sreq)
     {
     cmd_0057();
     continue;
     }
   if(!strcmp(ctab[i],"n23") && sreq)
     {
     cmd_0140();
     continue;
     }
   if(!strcmp(ctab[i],"n33") && sreq)
     {
     cmd_0058();
     continue;
     }
   if(!strcmp(ctab[i],"n09") && sreq)
     {
     cmd_0059();
     continue;
     }
   if(!strcmp(ctab[i],"n12") && sreq)
     {
     cmd_0060();
     continue;
     }
   if(!strcmp(ctab[i],"n17") && sreq)
     {
     cmd_0061();
     continue;
     }
   if(!strcmp(ctab[i],"n19") && sreq)
     {
     cmd_0074();
     continue;
     }
   if(!strcmp(ctab[i],"n04") && sreq)
     {
     cmd_0062();
     continue;
     }
   if(!strcmp(ctab[i],"n05") && sreq)
     {
     cmd_0063();
     continue;
     }
   if(!strcmp(ctab[i],"n13") && sreq)
     {
     cmd_0065();
     continue;
     }
   if(!strcmp(ctab[i],"ttl") && sreq)
     {
     cmd_0129();
     continue;
     }
   if(!strcmp(ctab[i],"ttc") && sreq)
     {
     cmd_0130();
     continue;
     }
   if(!strcmp(ctab[i],"ttr") && sreq)
     {
     cmd_0131();
     continue;
     }
   if(!strcmp(ctab[i],"g") && sreq)
     {
     cmd_0134();
     continue;
     }
   if(!strcmp(ctab[i],"p") && sreq)
     {
     cmd_0135();
     continue;
     }
   if(!strcmp(ctab[i],"net") && sreq)
     {
     cmd_0136();
     continue;
     }
   if(!strcmp(ctab[i],"netend") && sreq)
     {
     cmd_0137();
     continue;
     }
   if(!strcmp(ctab[i],"tab") && sreq)
     {
     cmd_0066();
     continue;
     }
   if(!strcmp(ctab[i],"flt") && sreq)
     {
     cmd_0067();
     continue;
     }
   if(!strcmp(ctab[i],"n00") && sreq)
     {
     cmd_0068();
     continue;
     }
   if(!strcmp(ctab[i],"l") && sreq)
     {
     cmd_0069();
     continue;
     }
   if(!strcmp(ctab[i],"col") && sreq)
     {
     cmd_0113();
     continue;
     }
   if(!strcmp(ctab[i],"punch") && sreq)
     {
     cmd_0114();
     continue;
     }
   if(!strcmp(ctab[i],"and") && sreq)
     {
     cmd_0141();
     continue;
     }

IFLINE: ;
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"n") && isps(ctab[i+m+1]))
     {
     cmd_0022();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"u") && isps(ctab[i+m+1]))
     {
     cmd_0023();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"u") && (n = coladr(&t_val,i+m+1,count,bbuf)))
     {
     cmd_0024();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"=") && (n = coladr(&t_val,i+m+1,count,bbuf)))
     {
     cmd_0025();
     continue;
     }
   if((m = varadr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"in"))
     {
     cmd_0100();
     continue;
     }
   if(!strcmp(ctab[i],"and"))
     {
     cmd_0037();
     continue;
     }
   if(!strcmp(ctab[i],"or"))
     {
     cmd_0038();
     continue;
     }
   if(!strcmp(ctab[i],"not"))
     {
     cmd_0039();
     continue;
     }
   if(!strcmp(ctab[i],"lt"))
     {
     cmd_0040();
     continue;
     }
   if(!strcmp(ctab[i],"gt"))
     {
     cmd_0041();
     continue;
     }
   if(!strcmp(ctab[i],"eq"))
     {
     cmd_0042();
     continue;
     }
   if(!strcmp(ctab[i],"le"))
     {
     cmd_0043();
     continue;
     }
   if(!strcmp(ctab[i],"ge"))
     {
     cmd_0044();
     continue;
     }
   if(!strcmp(ctab[i],"ne"))
     {
     cmd_0045();
     continue;
     }
   if(!strcmp(ctab[i],"nobits_"))
     {
     cmd_0115();
     continue;
     }
   goto OTHER;

NO_IFLINE: ;
   if(!strcmp(ctab[i],",") && isemit)
     {
     cmd_0002();
     continue;
     }
   if(!strcmp(ctab[i],",") && isdel)
     {
     cmd_0003();
     continue;
     }
   if(!strcmp(ctab[i],",") && ismask)
     {
     cmd_0133();
     continue;
     }
   if(!strcmp(ctab[i],",") && isset)
     {
     cmd_0004();
     continue;
     }
   if(!strcmp(ctab[i],"set") && !afound && sreq)
     {
     cmd_0013();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) &&
   ((i+m+2) < count) && isps(ctab[i+m]) &&
   !strcmp(ctab[i+m+1],"=") && (n = coladr(&t_val,i+m+2,count,bbuf)) &&
   ((i+m+2+n) < count) && isps(ctab[i+m+2+n]))
     {
     cmd_0021();
     continue;
     }
   if((m = varadr(&t_val,i,count,abuf)) && ((i+m) < count) && !strcmp(ctab[i+m],"="))
     {
     cmd_0102();
     continue;
     }
   if(i && (m = varadr(&t_val,i,count,abuf)) && iseopr(ctab[i-1]))
     {
     cmd_0103();
     continue;
     }
   if(!strcmp(ctab[i],"emit") && !afound && sreq)
     {
     cmd_0028();
     continue;
     }
   if(!strcmp(ctab[i],"delete") && !afound && sreq)
     {
     cmd_0029();
     continue;
     }
   if(!strcmp(ctab[i],"mask") && !afound && sreq)
     {
     cmd_0132();
     continue;
     }
   if(!strcmp(ctab[i],"priority") && !afound && sreq)
     {
     cmd_0030();
     continue;
     }
   if(!strcmp(ctab[i],"clear") && !afound && sreq)
     {
     cmd_0099();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1)<count)
      && !strcmp(ctab[i+m],"=") && !strcmp(ctab[i+m+1],"or"))
     {
     cmd_0034();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1)<count)
      && !strcmp(ctab[i+m],"=") && !strcmp(ctab[i+m+1],"and"))
     {
     cmd_0035();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1)<count)
      && !strcmp(ctab[i+m],"=") && !strcmp(ctab[i+m+1],"xor"))
     {
     cmd_0036();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1)<count)
      && !strcmp(ctab[i+m],"=") && !strcmp(ctab[i+m+1],"rpunch"))
     {
     cmd_0112();
     continue;
     }
   if(!strcmp(ctab[i],"if") && !iscall && sreq)
     {
     cmd_0046();
     continue;
     }
   if(!strcmp(ctab[i],"call") && !afound && sreq)
     {
     cmd_0047();
     continue;
     }
   if(!strcmp(ctab[i],"subroutine") && !afound && edfound && sreq)
     {
     cmd_0048();
     continue;
     }
   if(!strcmp(ctab[i],"process") && !afound && sreq)
     {
     cmd_0071();
     continue;
     }
   if(!strcmp(ctab[i],"reject") && !afound && sreq)
     {
     cmd_0073();
     continue;
     }
   if(!strcmp(ctab[i],"filedef") && !afound && sreq)
     {
     cmd_0107();
     continue;
     }
   if(!strcmp(ctab[i],"definelist") && !afound && sreq)
     {
     cmd_0075();
     continue;
     }
   if(!strcmp(ctab[i],"int") && !subfound && !afound && sreq)
     {
     cmd_0076();
     continue;
     }
   if(!strcmp(ctab[i],"real") && !subfound && !afound && sreq)
     {
     cmd_0077();
     continue;
     }
   if(!strcmp(ctab[i],"data") && !subfound && !afound && sreq)
     {
     cmd_0078();
     continue;
     }
   if(!strcmp(ctab[i],"int") && subfound && !afound && sreq)
     {
     cmd_0079();
     continue;
     }
   if(!strcmp(ctab[i],"real") && subfound && !afound && sreq)
     {
     cmd_0080();
     continue;
     }
   if(!strcmp(ctab[i],"data") && subfound && !afound && sreq)
     {
     cmd_0081();
     continue;
     }
   if(!strcmp(ctab[i],"stop") && !afound && sreq)
     {
     cmd_0082();
     continue;
     }
   if(!strcmp(ctab[i],"do") && !afound && sreq)
     {
     cmd_0084();
     continue;
     }
   if(!strcmp(ctab[i],"continue") && !afound && sreq)
     {
     cmd_0085();
     continue;
     }
   if(!strcmp(ctab[i],"else") && !afound && sreq)
     {
     cmd_0086();
     continue;
     }
   if(!strcmp(ctab[i],"goto") && !afound && sreq)
     {
     cmd_0087();
     continue;
     }
   if((i+1)<count && !strcmp(ctab[i],"go") && !strcmp(ctab[i+1],"to") && !afound && sreq)
     {
     cmd_0087();
     continue;
     }
   if((!strcmp(ctab[i],"r") || !strcmp(ctab[i],"require")) && !afound && sreq)
     {
     cmd_0091();
     continue;
     }
   if((!strcmp(ctab[i],"print") || !strcmp(ctab[i],"write")) && !afound && sreq)
     {
     cmd_0092();
     continue;
     }
   if(!strcmp(ctab[i],"count") && !afound && sreq)
     {
     cmd_0093();
     continue;
     }
   if(!strcmp(ctab[i],"list") && !afound && sreq)
     {
     cmd_0096();
     continue;
     }
   if(!strcmp(ctab[i],"lista") && !afound && sreq)
     {
     cmd_0096();
     continue;
     }
   if(!strcmp(ctab[i],"listr") && !afound && sreq)
     {
     cmd_0096();
     continue;
     }
   if(!strcmp(ctab[i],"listc") && !afound && sreq)
     {
     cmd_0096();
     continue;
     }
   if((!strcmp(ctab[i],"report") || !strcmp(ctab[i],"reportn")) && !afound && sreq)
     {
     cmd_0109();
     continue;
     }
   if(!strcmp(ctab[i],"rqd") && !afound && sreq)
     {
     cmd_0106();
     continue;
     }
   if(!strcmp(ctab[i],"nobounds") && !afound && sreq)
     {
     cmd_0110();
     continue;
     }
   if(!strcmp(ctab[i],"then") && !afound && sreq)
     {
     cmd_0116();
     continue;
     }
   if(!strcmp(ctab[i],"endif") && !afound && sreq)
     {
     cmd_0117();
     continue;
     }
   if(!strcmp(ctab[i],"display") && !afound && sreq)
     {
     cmd_0119();
     continue;
     }
   if(!strcmp(ctab[i],"beep") && !afound && sreq)
     {
     cmd_0121();
     continue;
     }
   if(!strcmp(ctab[i],"single") && !afound && sreq)
     {
     cmd_0122();
     continue;
     }
   if(!strcmp(ctab[i],"system") && !afound && sreq)
     {
     cmd_0123();
     continue;
     }
   if(!strcmp(ctab[i],"multi") && !afound && sreq)
     {
     cmd_0124();
     continue;
     }
   if(!strcmp(ctab[i],"num") && !afound && sreq)
     {
     cmd_0125();
     continue;
     }
   if(!strcmp(ctab[i],"noescape") && !afound && sreq)
     {
     cmd_0126();
     continue;
     }
   if(!strcmp(ctab[i],"escape") && !afound && sreq)
     {
     cmd_0127();
     continue;
     }
   if(!strcmp(ctab[i],"cancel") && !afound && sreq)
     {
     cmd_0128();
     continue;
     }
   if(!strcmp(ctab[i],"debug") && !afound && sreq)
     {
     cmd_0139();
     continue;
     }
   if(!strcmp(ctab[i],"check_") && !afound && sreq)
     {
     cmd_0142();
     continue;
     }
   if(!strcmp(ctab[i],"nocheck_") && !afound && sreq)
     {
     cmd_0143();
     continue;
     }
   if(!strcmp(ctab[i],"errprint") && !afound && sreq)
     {
     cmd_0144();
     continue;
     }
   goto OTHER;

OTHER: ;
   if(!strcmp(ctab[i],";"))
     {
     cmd_0001();
     continue;
     }
   if(!strcmp(ctab[i],"+"))
     {
     cmd_0006();
     continue;
     }
   if(!strcmp(ctab[i],"-"))
     {
     cmd_0007();
     continue;
     }
   if(!strcmp(ctab[i],"*"))
     {
     cmd_0008();
     continue;
     }
   if(!strcmp(ctab[i],"/"))
     {
     cmd_0009();
     continue;
     }
   if(!strcmp(ctab[i],")"))
     {
     cmd_0010();
     continue;
     }
   if(!strcmp(ctab[i],"("))
     {
     cmd_0011();
     continue;
     }
   if(!strcmp(ctab[i],"struct") && !edfound)
     {
     cmd_0014();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m+1) < count) && !strcmp(ctab[i+m],"=")
      && isps(ctab[i+m+1]))
     {
     cmd_0026();
     continue;
     }
   if((m = coladr(&t_val,i,count,abuf)) && ((i+m) < count) && isps(ctab[i+m]))
     {
     cmd_0027();
     continue;
     }
   if((ifline || iscall) && (m = varadr(&t_val,i,count,abuf)))
     {
     cmd_0101();
     continue;
     }
   if(!i && isnumb(ctab[i]) == NINT)
     {
     cmd_0088();
     continue;
     }
   if((k = setcol(&diffa,i,count,abuf)))
     {
     cmd_0095();
     continue;
     }
   if(isnumb(ctab[i]) && i)
     {
     cmd_0104();
     continue;
     }
   if(!strcmp(ctab[i],"numb"))
     {
     cmd_0031();
     continue;
     }
   if(!strcmp(ctab[i],"random"))
     {
     cmd_0111();
     continue;
     }
   if(!strcmp(ctab[i],"range"))
     {
     cmd_0032();
     continue;
     }
   if(!strcmp(ctab[i],"rangeb"))
     {
     cmd_0033();
     continue;
     }
   if(!strcmp(ctab[i],"return") && sreq)
     {
     cmd_0072();
     continue;
     }
   if(!strcmp(ctab[i],"ed") && !edfound && sreq)
     {
     cmd_0090();
     continue;
     }
   if(!strcmp(ctab[i],"end") && sreq)
     {
     cmd_0050();
     continue;
     }
   if(!strcmp(ctab[i],"ed_dummy_command") && !out1_yes)
     {
     cmd_0049();
     continue;
     }
   if(!strcmp(ctab[i],"a") && !i && !isedit && !afound && sreq)
     {
     cmd_0070();
     continue;
     }
   if(!strcmp(ctab[i],"online") && edfound && !afound && sreq)
     {
     cmd_0108();
     continue;
     }
   if(ifline)
     errmsg("\0", 32);
   else
     errmsg("\0", 16);
   }

/* struct - keyword combination pruefen */
if(isstruct)
  {
  if((sreadtype == 2 || sreadtype == 3) && sreclen > 100)
    {
    if(sreclen > 1000)
      errmsg("\0", 63);
    else
      {
      errmsg("\0", 62);
      sreclen = 1000;
      printf("%d columns per card will be allocated in data pass\n",sreclen);
      }
    }
  else
  if(sreadtype == 0 && sreclen > 99999)
    errmsg("\0", 93);
  if(sreadtype == 2 && !sserlen)
    errmsg("\0", 50);
  else
  if(sreadtype == 2 && !scrdlen)
    errmsg("\0", 50);
  else
  if(isrep && !scrdlen)
    errmsg("\0", 50);
  else
  if(sreadtype == 0 && smaxcrd)
    errmsg("\0", 50);
  else
  if(sreadtype == 0 && scrdlen)
    errmsg("\0", 50);
  else
  if(sreadtype == 0 && isreq)
    errmsg("\0", 50);
  else
  if(sreadtype == 0 && isrep)
    errmsg("\0", 50);
  else
  if(sreadtype == 3 && isreq)
    errmsg("\0", 50);
  else
  if(sreadtype == 3 && isrep)
    errmsg("\0", 50);
  else
  if(sreadtype == 3 && !sserlen)
    errmsg("\0", 50);
  else
  if(sreadtype == 3 && scrdlen)
    errmsg("\0", 50);
  }

k = 1;
while(k)
  {
  strcpy(buf,wbuf);
  k = 0;
  len = strlen(buf);

  count = 0; mjn = 0;
  for(i=0;i<len;i++)
     {
     if(*(buf + i) != ' ')
       {
       if(!mjn)
         {
         ctab[count++] = buf + i;
         mjn = 1;
         }
       }
       else
       {
       *(buf + i) = '\0';
       mjn = 0;
       }
     }
  strcpy(wbuf,"\0");
  for(i=0;i<count;i++)
     {
     if((m = setcol(&diffa,i,count,zbuf)) && !(((i+1)<count) && !strcmp(ctab[i+1],"##")))
       {
       if(pvargen(ctab[i]) == COLDBL)
         {
         if(((i+m)<count) && !strcmp(ctab[i+m],"="))
           errmsg("\0", 47);
         strcat(wbuf,"fcolfnc_ ( ");
         }
       else
         strcat(wbuf,"colfnc_ ( ");
       strcat(wbuf,zbuf);
       strcat(wbuf,") ");
       k = 1; i += (m-1);
       }
     else
     if(!strcmp(ctab[i],"numb"))
       {
       cmd_0031();
       continue;
       }
     else
       {
       strcat(wbuf,ctab[i]);
       strcat(wbuf," ");
       }
     }
  }

k = 1;
while(k)
  {
  strcpy(buf,wbuf);
  k = 0;
  len = strlen(buf);

  count = 0; mjn = 0;
  for(i=0;i<len;i++)
     {
     if(*(buf + i) != ' ')
       {
       if(!mjn)
         {
         ctab[count++] = buf + i;
         mjn = 1;
         }
       }
       else
       {
       *(buf + i) = '\0';
       mjn = 0;
       }
     }
  strcpy(wbuf,"\0"); mjn = 0;
  for(i=0;i<count;i++)
     {
     if(!strcmp(ctab[i],"/*"))
       mjn = 1;
     else
     if(!strcmp(ctab[i],"*/"))
       mjn = 0;
     if(!mjn && (m = varpar(i,count,zbuf)))
       {
       strcat(wbuf,zbuf);
       i += (m-1);
       if(m > 1)
         k = 1;
       }
     else
       {
       strcat(wbuf,ctab[i]);
       strcat(wbuf," ");
       }
     }
  }

if(iscolint)
  strcat(wbuf,") ) ");
else
if(t_par)
  strcat(wbuf,") ) ");
else
if(iscolreal)
  strcat(wbuf,") ");

if(kl && nignore)
  strcat(wbuf,"; ");

ll = klcount - thprec;
while(ll)
  {
  strcat(wbuf,"} ");
  --klcount; --ll;
  }

if(enddo)
  strcat(wbuf,"} ");

len = strlen(wbuf);

j = 0;ll = 0;
for(i=0;i<len;i++)
   {
   if(*(wbuf+i) == '"')
     ll = (int)1 - ll;
   if(!ll)
     {
     if(*(wbuf + i) == '(' || *(wbuf + i) == '[')
       j++;
     else
     if(*(wbuf + i) == ')' || *(wbuf + i) == ']')
       j--;
     }
   }
if(j)
  errmsg("\0", 18);

for(j=0;j<100;j++)
   errindx[j] = 0;

return(wbuf);
}
